@use crate::templates::base_html;
@use crate::all_versions::AllVersions;
@use crate::Urler;

@(url: &Urler, c: &AllVersions<'_>)

@:base_html(&c.page(), {
  <header id="package" @if c.is_yanked {class="yanked"}>
    <div class="inner-col">
    <div class="breadcrumbs">
    <h1>
      <a href="/"><span>Lib</span>.rs</a>
    </h1>
     › <a href="@url.crate_by_origin(&c.origin)" rel="up">@c.capitalized_name</a>
     › Versions
    </div>
    <nav><ul>
      <li><a href="@url.crate_by_origin(&c.origin)">Latest version</a></li>
      <li class=active>All Versions</li>
      @if let Some(url) = &c.changelog_url {
        <li><a href="@url">Changelog</a></li>
      }
      @if let Some(url) = url.reverse_deps(&c.origin) {
        <li><a href="@url">Reverse dependencies</a></li>
      }
    </ul></nav>
    </div>
  </header>
  <main>
    <div class="inner-col">
      <table class="all-versions">
        <tr><th class="ver">Version</th><th class="date">Released</th>
          @if c.has_authors {
            <th>By</th>
          }
          @if c.has_feat_changes {
            <th>Features</th>
          }
          @if c.has_deps_changes {
            <th class="deps">Dependency changes</th>
          }
          <th class="dl">Downloads/<abbr title="month">mo</abbr></th>
          <th class="msrv"><abbr title="minimum supported rust version">MSRV</abbr></th>
        </tr>
      @for v in c.version_history.iter().rev() {
        <tr class="@if v.yanked {yanked} @if v.is_semver_major_change {break}" id="version-@v.version">
          <th class="ver">
            @if !v.yanked {
              @if let Some(url) = url.crates_io_crate_at_version(&c.origin, &v.version.to_string()) {
                <a href="@url">@if let (ver, suffix) = v.version_split() {
                  @ver@if let Some(s) = suffix {<span>+@s</span>}
                }</a>
              } else if let (ver, suffix) = v.version_split() {
                @ver@if let Some(s) = suffix {<span>+@s</span>}
              }
            } else {
              <del title="yanked">@if let (ver, suffix) = v.version_split() {
                @ver@if let Some(s) = suffix {<span>+@s</span>}
              }</del>
            }
            @if let Some(url) = &v.security_advisory_url {
              <a href="@url" title="issue">⚠️</a>
            }
            @if let Some(url) = &v.version_url { [<a class="src" rel="nofollow" href="@url" title="source code">@v.version_url_label</a>] }
          </th>
          <td class="date">
            @if v.yanked { <del> }
            @v.release_date.format("%b %e, %Y")
            @if v.yanked { <del> }
          </td>
          @if c.has_authors && !c.authors_in_feat_column {
            <td>@if let Some((login, name)) = &v.published_by {
                @if v.yanked && v.yanked_by != v.published_by { <del> }
                <a href="@url.crate_owner_by_github_login(login)">@name.as_deref().unwrap_or(login)</a>
                @if v.yanked && v.yanked_by != v.published_by { </del> }
              }
              @if v.yanked && v.yanked_by != v.published_by {
                @if let Some((login, name)) = &v.yanked_by {
                  <div class="yanked" title="yanked by"><a href="@url.crate_owner_by_github_login(login)">@name.as_deref().unwrap_or(login)</a></div>
                }
              }
            </td>
          }

          @if c.has_feat_changes {
          <td class="feat" @if c.authors_in_feat_column { colspan="2" }>
            @if c.has_authors && c.authors_in_feat_column {
              <div class="by">@if let Some((login, name)) = &v.published_by {
                  @if v.yanked && v.yanked_by != v.published_by { <del> }
                  <a href="@url.crate_owner_by_github_login(login)">@name.as_deref().unwrap_or(login)</a>
                  @if v.yanked && v.yanked_by != v.published_by { </del> }
                }
                @if v.yanked && v.yanked_by != v.published_by {
                  @if let Some((login, name)) = &v.yanked_by {
                    <div class="yanked" title="yanked by"><a href="@url.crate_owner_by_github_login(login)">@name.as_deref().unwrap_or(login)</a></div>
                  }
                }
              </div>
            }
            @if !v.feat_added.is_empty() || !v.feat_removed.is_empty() {
              @if c.authors_in_feat_column && v.published_by.is_some() {
                <p>Feature@if v.feat_added.is_empty() {s removed} else if v.feat_removed.is_empty() {s added} else { changes}</p>
              }
              <ul>
                @for f in &v.feat_added {
                  <li class="add"><ins>@if c.most_recent_features.contains(f) {<a href="@url.features(&c.origin, Some(f))">@f</a>} else {@f}</ins></li>
                }
                @for f in &v.feat_removed {
                  <li class="rm"><del>@f</del></li>
                }
              </ul>
            }
          </td>
          }
          @if c.has_deps_changes {
          <td class="deps">
            @if !v.deps_added.is_empty() || !v.deps_upgraded.is_empty() || !v.deps_removed.is_empty() || v.links_changed.is_some() {
              <ul>
                @for (dep, origin) in &v.deps_added {
                  <li class="add"><ins><a href="@url.crate_by_origin(origin)">@dep</a></ins></li>
                }
                @for (dep, ver, link_it) in &v.deps_upgraded {
                  <li class="up">@if let Some(origin) = link_it {<a
                    href="@url.all_versions(origin).unwrap_or_else(||url.crate_by_origin(origin))#version-@ver">}@dep <ins>@ver</ins>@if link_it.is_some() {</a>}
                  </li>
                }
                @for (i, dep) in v.deps_removed.iter().enumerate() {
                  <li class="rm"><del @if i==0 {title="removed"}>@dep</del></li>
                }
                @if let Some((new_links, prev_links)) = v.links_changed {
                  <li>links @if let Some(new_links) = new_links {<code>@new_links</code>}
                    else {<del title="removed">@prev_links.unwrap_or("links")</del>}</li>
                }
              </ul>
            }
          </td>
          }
          <td class="dl">
            @if v.dl.num >= 100 || v.dl.perc > 0.0125 {
              @if v.dl.perc > 0.0125 {
                <span style="width:@v.dl.perc%">@if v.dl.perc > v.dl.num_width {@v.dl.str.0<b>@v.dl.str.1</b>}</span>
              }
              @if v.dl.perc <= 0.0125 || v.dl.perc <= v.dl.num_width {@v.dl.str.0<b>@v.dl.str.1</b>}
            }
          </td>
          <td class="msrv">
            @if let Some((min, max, checked)) = v.msrv {
              @if min == max {
                @if !checked && max > 1 {1.@max~} else {1.@max}
              } else {
                1.@max~1.@min
              }
            }
          </td>
        </tr>
      }
      </table>
      @if !c.has_authors {
        @if let Some(only_owner) = &c.only_owner {
          @if let Some(login) = only_owner.github_login() {
            <p>All published by <a href="@url.crate_owner_by_github_login(login)">@only_owner.name().unwrap_or(login)</a>.</p>
          }
        }
      }
      <p>Minimum Supported Rust Version (<abbr>MSRV</abbr>) is only approximate. A range of two versions means "oldest rustc verified to work ~ oldest rustc that might work". Actual <abbr>MSRV</abbr> will vary depending on crate features, target platform, and dependency versions. The data is estimated based on the latest stable Rust version available at the time the crate has been published and <code>cargo check</code> or <code>cargo clippy</code> on Linux/aarch64.</p>
    </div>
  </main>

  <footer>
    <div class="inner-col">
        <p>Back to <a href="@url.crate_by_origin(&c.origin)" rel="up">@c.capitalized_name</a>.</p>
    </div>
  </footer>
})
